Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Text.RegularExpressions

<DefaultProperty("Text"), ToolboxData("<{0}:CreditCardValidator runat=server></{0}:CreditCardValidator>")> _
Public Class CreditCardValidator
    Inherits System.Web.UI.WebControls.BaseValidator

    Private myTextBox As TextBox

    Private objcardtype As CardTypes

    Public Property CardType() As CardTypes
        Get
            Return objcardtype
        End Get
        Set(ByVal Value As CardTypes)
            objcardtype = Value
        End Set
    End Property


    Protected Overrides Function ControlPropertiesValid() As Boolean
        Dim ctrl As Control
        ctrl = FindControl(ControlToValidate)
        If Not ctrl Is Nothing Then
            myTextBox = ctrl
            Return True
        Else
            Return False
        End If
    End Function

    Protected Overrides Function EvaluateIsValid() As Boolean
        If IsValidForLuhnLogic(myTextBox.Text) And IsValidForCardType(myTextBox.Text, CardType) Then
            Return True
        Else
            Return False
        End If
    End Function


    Private Function IsValidForLuhnLogic(ByVal cardnumber As String) As Boolean
        Dim strCCNumber As String
        strCCNumber = cardnumber

        Dim strRev As String
        Dim strCh As String
        Dim intNumber As Integer
        Dim strNumberFinal As String
        Dim intSum As Integer
        Dim validLuhn As Boolean
        Dim intTemp As Integer

        strRev = StrReverse(strCCNumber)
        Try
            For intTemp = 1 To Len(strRev)
                strCh = Mid(strRev, intTemp, 1)
                intNumber = CInt(strCh)
                If intTemp Mod 2 = 0 Then
                    intNumber = intNumber * 2
                    If intNumber > 9 Then
                        intNumber = intNumber - 9
                    End If
                End If
                strNumberFinal = strNumberFinal & intNumber
            Next intTemp
            For intTemp = 1 To Len(strNumberFinal)
                intSum = intSum + Mid(strNumberFinal, intTemp, 1)
            Next intTemp

            If intSum Mod 10 = 0 Then
                validLuhn = True
            Else
                validLuhn = False
            End If
        Catch
            validLuhn = False
        End Try
        Return validLuhn
    End Function

    Private Function IsValidForCardType(ByVal cardnumber As String, ByVal cardtyp As CardTypes) As Boolean
        Dim validType As Boolean = False

        Select Case cardtyp
            Case CardTypes.VISA
                If (Regex.IsMatch(cardnumber, "^(4)")) And (cardnumber.Length = 16 Or cardnumber.Length = 13) Then
                    validType = True
                End If
            Case CardTypes.MASTERCARD
                If (Regex.IsMatch(cardnumber, "^(5[1-5])")) And cardnumber.Length = 16 Then
                    validType = True
                End If
            Case CardTypes.AMERICANEXPRESS
                If (Regex.IsMatch(cardnumber, "^3(4|7)")) And cardnumber.Length = 15 Then
                    validType = True
                End If
            Case Else
                validType = False
        End Select
        Return validType
    End Function

    'Protected Overrides Sub OnPreRender(ByVal e As System.EventArgs)
    '    MyBase.OnPreRender(e)
    '    Dim sb As New System.Text.StringBuilder
    '    sb.Append("<script>function Test(val)")
    '    sb.Append("{")
    '    sb.Append("alert(document.getElementById(val.controltovalidate).value);")
    '    sb.Append("return false;}</script>")

    '    Page.RegisterClientScriptBlock(TypeName(Me), sb.ToString)



    'End Sub

    Protected Overrides Sub AddAttributesToRender(ByVal writer As System.Web.UI.HtmlTextWriter)
        MyBase.AddAttributesToRender(writer)
        writer.AddAttribute("evaluationfunction", "ValidateCreditCard")
        writer.AddAttribute("cardtype", CardType.ToString)

    End Sub
End Class

Public Enum CardTypes
    VISA
    MASTERCARD
    AMERICANEXPRESS
End Enum
